﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Shapes;
using System.Windows.Media;
using System;

namespace WpfApplication20
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Point previousePoint;
        private Rectangle draggingRect;
        private Random random;

        public MainWindow()
        {
            InitializeComponent();
            random = new Random();

            for (int i = 0; i < 20; i++)
            {
                Rectangle rect = new Rectangle();
                rect.Width = 30;
                rect.Height = 30;
                rect.Fill = new SolidColorBrush(Colors.Red);
                rect.Stroke = new SolidColorBrush(Colors.Black);
                rect.StrokeThickness = 2;
                rect.MouseDown += Rectangle_MouseDown;
                Canvas.SetLeft(rect, random.Next(790));
                Canvas.SetTop(rect, random.Next(590));
                Panel.Children.Add(rect);
            }
        }

        private void Rectangle_MouseDown(object sender, MouseButtonEventArgs e)
        {
            draggingRect = (Rectangle)sender;
        }

        private void Canvas_MouseMove(object sender, MouseEventArgs e)
        {
            var newPoint = e.GetPosition(this);
            if (draggingRect != null)
            {
                if (!previousePoint.Equals(default(Point)))
                {
                    double offsetX = newPoint.X - previousePoint.X;
                    double offsetY = newPoint.Y - previousePoint.Y;
                    double left = Canvas.GetLeft(draggingRect);
                    double top = Canvas.GetTop(draggingRect);
                    Canvas.SetLeft(draggingRect, left + offsetX);
                    Canvas.SetTop(draggingRect, top + offsetY);
                }
            }
            previousePoint = newPoint;
        }

        private void Canvas_MouseUp(object sender, MouseButtonEventArgs e)
        {
            draggingRect = null;
        }
    }
}
